if ("undefined" == typeof (DigitalFolio)) {
    var DigitalFolio = {};
};

(function () {   
    var public = null;
    var mainWindow = null;    
    var sideBarBrowser = null;
    var folioDataElement = null; 
    var availableExtensionVersion;

    this.init = function() {
        public = this;

        mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
            .getInterface(Components.interfaces.nsIWebNavigation)
            .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
            .rootTreeItem
            .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
            .getInterface(Components.interfaces.nsIDOMWindow);
        sideBarBrowser = document.getElementById("sideBarBrowser");
        var sideBarBox = mainWindow.document.getElementById("sidebar-box");
        sideBarBox.minWidth = 263;

        mainWindow.gBrowser.tabContainer.addEventListener("TabSelect", mainWindowTabSelected, false);

        mainWindow.gBrowser.addEventListener("DOMContentLoaded", onUserPageLoad, true);

        window.addEventListener("dragenter", DrageEnter, false);
        sideBarBrowser.addEventListener("dragover", DragOver, false);
        window.addEventListener("drop", DropCompleted, false);

        SubscribeToPluginEvent("SilverlightLoaded", function(e) { sideBarBrowserHandlers.silverlightLoaded(e); });
        SubscribeToPluginEvent("SetAjaxRegex", function(e) { sideBarBrowserHandlers.setAjaxRegex(e); });
        SubscribeToPluginEvent("DoGetRequest", function(e) { sideBarBrowserHandlers.doGetRequest(e); });
        SubscribeToPluginEvent("DoPostRequest", function(e) { sideBarBrowserHandlers.doPostRequest(e); });
        SubscribeToPluginEvent("OpenNewTab", function(e) { sideBarBrowserHandlers.openNewTab(e); });
        SubscribeToPluginEvent("NavigateUser", function(e) { sideBarBrowserHandlers.navigateUser(e); });

        mainWindow.addEventListener('dragstart', DocDragStart, false);
        mainWindow.addEventListener('dragend', DocDragEnd, false);

        GetAvailableExtensionVersion(CheckExtensionVersion);
    };  

    function mainWindowTabSelected(e) {
        public.notifySideBarBrowser.BrowserHtmlChanged(mainWindow.gBrowser.contentDocument.location.href);
        AttachAnchorEvents();      
    }

    function GetAvailableExtensionVersion(callback) {
        var data = "browser=ff";
        
        var req = new XMLHttpRequest();
        req.open('POST', "http://www.digitalfolio.com/Plug_In/CurrentExtensionVersion", true);
        req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        req.setRequestHeader("Content-length", data.length);

        req.onreadystatechange = function (aEvt) {
            if (req.readyState == 4) {
                if (req.status == 200) {
                    //dump(req.responseText);
                    availableExtensionVersion = req.responseText;
                    if(callback)
                        callback();
                }

                else
                    dump("Error loading page\n");
            }
        };
        req.send(data);    
    }
    
    function CheckExtensionVersion(){
        DigitalFolioMetaData.getVersionNumber(function (userExtensionVersion){

            var versionDifference = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
                            .getService(Components.interfaces.nsIVersionComparator)
                            .compare(userExtensionVersion, availableExtensionVersion);
        
            if(versionDifference == 0){
                // same
            }
            else if (versionDifference > 0){
                // later
            }
            else{
                // earlier         
                sideBarBrowser.style.display = "none";
                document.getElementById("updateContainer").style.display = "";  
                document.getElementById("txtCurrentVersionNumber").textContent = userExtensionVersion;
                document.getElementById("txtAvailableVersionNumber").textContent = availableExtensionVersion;
            } 

        });
    }

    function onUserPageLoad(e) {
        var senderUrl = e.target.URL;

		// matches javascript and css files
        var re = /\.js\b|\.css\b/i;
        
        if(senderUrl.match(re))
            return;

        public.notifySideBarBrowser.BrowserHtmlChanged(e.target.URL);
        AttachAnchorEvents();    
        
        var mainBrowserDoc = mainWindow.gBrowser.contentDocument;
        //mainBrowserDoc.addEventListener('ChangeSidebarUrl', this.ChangeSideBarUrl);    
    }

    this.ChangeSideBarUrl = function(url) {
        var currentLowered = sideBarBrowser.contentDocument.location.href.toLowerCase();
        var urlLowered = url.toLowerCase();
        if (currentLowered != urlLowered)
            sideBarBrowser.contentDocument.location.href = url;
    };

     // matches target.com listing urls /c/, /s/, /s?
    var ajaxRegex = new RegExp("target.com\/(?:(?:(?:c|s|sb)\/)|s\?)", "i");

    function AttachAnchorEvents() {
        var mainBrowserDoc = mainWindow.gBrowser.contentDocument;
        //Application.console.log(ajaxRegex.source);
        try {           

            if(mainBrowserDoc.location.href.match(ajaxRegex)) {                
                mainBrowserDoc.addEventListener("mouseup", DocMouseUp, false);                
            }      
                  
            mainBrowserDoc.addEventListener("mouseover", DocMouseOver, false);
            mainBrowserDoc.addEventListener("dragstart", DocDragStart, false);
            mainBrowserDoc.addEventListener("dragend", DocDragEnd, false);
        }
        catch (error) {
        }
    }

    function SubscribeToPluginEvent(eventName, handlerFunction) {
        document.addEventListener(eventName, handlerFunction, false, true); // The last value is a Mozilla-specific value to indicate untrusted content is allowed to trigger the event.
    }

    function DocMouseUp(e) {
        var mainBrowserDoc = mainWindow.gBrowser.contentDocument;
        var tagName = e.target.tagName.toLowerCase();
        //Application.console.log(tagName);
        if (tagName == 'div' || tagName == 'a' || tagName == 'option'|| tagName == 'img' || tagName == 'span') { 
            // wait 2 sec and send the html
            window.setTimeout(function() {
                public.notifySideBarBrowser.BrowserHtmlChanged(mainBrowserDoc.location.href);
            }, 1000);            
        }        
    }

    function DocMouseOver(e) {
        //Application.console.log(e.target.tagName.toLowerCase());

        var node;

        if(e.target.tagName.toLowerCase() == 'a')
            node = e.target;
        else if(e.target.parentNode != null && e.target.parentNode.tagName.toLowerCase() == 'a')
            node = e.target.parentNode;

        if(node){
            var foliodata = GetFolioDataElement();
            if (foliodata) {            
                foliodata.setAttribute("anchorHoveredHref", node.href);
                public.notifySideBarBrowser.Notify("AnchorHovered", foliodata);                
            }
        }
    }

    function DocDragStart(e) {
        if (e.target.tagName.toLowerCase()  == 'a') {
            public.notifySideBarBrowser.ShowDropZone(true);
        }
        else if (e.target.id == 'page-proxy-favicon') {
            public.notifySideBarBrowser.ShowDropZone(true);
        }
    }

    function DocDragEnd(e) {
        if (e.target.tagName.toLowerCase()  == 'a') {
            public.notifySideBarBrowser.ShowDropZone(false);
        }
        else if (e.target.id == 'page-proxy-favicon') {
            public.notifySideBarBrowser.ShowDropZone(false);
        }
    }

    function DrageEnter(e) {
        var links = e.dataTransfer.getData("text/uri-list").split("\n");
        if (links.length > 0) {
            //Application.console.log(links[0]);
        }
        public.notifySideBarBrowser.ShowDropZone(true);
    }

    function DragOver(e) {
        var links = e.dataTransfer.getData("text/uri-list").split("\n");
        if (links.length > 0) {
           e.preventDefault();
        }
        
        public.notifySideBarBrowser.ShowDropZone(true);
    }

    function DropCompleted(e) {
        var links = e.dataTransfer.getData("text/uri-list").split("\n");

        if (links.length > 0) {
            var url = links[0];
            if (IsWhiteListed(url)) {
                e.preventDefault();
                e.stopPropagation();
                sideBarBrowser.loadURI(url);
            }
            else {
                e.preventDefault();
                e.stopPropagation();
                public.notifySideBarBrowser.UrlDropped(url);
            }
        }
    }

    var sideBarBrowserHandlers = {
        silverlightLoaded: function(e) {
            var context = GetBrowserContext();

            AttachAnchorEvents();
            public.notifySideBarBrowser.BrowserHtmlChanged(context.CurrentUrl);
        },

        setAjaxRegex: function(e) {

            var regexString = e.target.getAttribute("regex");
            ajaxRegex = new RegExp(regexString, "i");

            //Application.console.log(ajaxRegex.source);
            sideBarBrowser.contentDocument.documentElement.removeChild(e.target);
        },

        openNewTab: function(e) {
            var url = e.target.getAttribute("newTabUrl");
            mainWindow.gBrowser.selectedTab = gBrowser.addTab(url);
        },

        navigateUser: function(e) {
            var url = e.target.getAttribute("navigateUserUrl");

            var mainBrowserDoc = mainWindow.gBrowser.contentDocument;
            mainBrowserDoc.location.href = url;
        },

        doGetRequest: function(e) {
            var requestUrl = e.target.getAttribute("requestUrl");
            var context = e.target.getAttribute("context");
            var cookie = e.target.getAttribute("cookie");
            var requestId = e.target.getAttribute("requestId");

            DoGetRequest(requestUrl, context, cookie, requestId);
        },

        doPostRequest: function(e) {
            var requestUrl = e.target.getAttribute("requestUrl");
            var data = e.target.getAttribute("data");
            var context = e.target.getAttribute("context");
            var cookie = e.target.getAttribute("cookie");
            var requestId = e.target.getAttribute("requestId");

            DoPostRequest(requestUrl, data, context, cookie, requestId);
        }
    };

    function DoGetRequest(requestUrl, context, cookie, requestId) {
        var req = new XMLHttpRequest();
        req.open('GET', requestUrl, true);
        
        if(cookie.length > 3) {
            if(cookie.indexOf(";") < 0)
                cookie += ";";
            req.setRequestHeader("Cookie", cookie);
        }
        req.setRequestHeader("Accept-Encoding", "gzip, deflate");
        req.onreadystatechange = function (aEvt) {
            if (req.readyState == 4) {
                if (req.status == 200) {
                    //dump(req.responseText);
//                    Application.console.log("Cookie: " + cookie);
//                    var newCookies = GetCookies(cookie, req);
//                    Application.console.log("New Cookie: " + newCookies);
                    public.notifySideBarBrowser.PluginWebRequestCompleted(req.responseText, requestUrl, context, cookie, requestId);
                }
                else {
                    var errorResponse = "Exception:||:" + req.status + ":||:" + req.responseText;
                    public.notifySideBarBrowser.PluginWebRequestCompleted(errorResponse, requestUrl, context, cookie, requestId);
                }
                    
            }
        };
        req.send(null);
    }
    
    function GetCookies(currentCookies, request) {
        var pattern = /Set-Cookie:\s*([^;]*;)/gi;
        var headers = request.getAllResponseHeaders();
        Application.console.log("Headers: " + headers);
        do {
            var match = pattern.exec(headers);
            if(match) {
                currentCookies += match[1];
            }
            
        } while (match != null)

        return currentCookies;
    }

    function DoPostRequest(requestUrl, data, context, cookie, requestId) {
        var req = new XMLHttpRequest();
        req.open('POST', requestUrl, true);
        req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        req.setRequestHeader("Content-length", data.length);
        req.setRequestHeader("Accept-Encoding", "gzip, deflate");
        
        if(cookie.length > 3) {
            if(cookie.indexOf(";") < 0)
                cookie += ";";
            req.setRequestHeader("Cookie", cookie);
        }

        req.onreadystatechange = function (aEvt) {
            if (req.readyState == 4) {
                if (req.status == 200) {
                    //dump(req.responseText);
                    public.notifySideBarBrowser.PluginWebRequestCompleted(req.responseText, requestUrl, context, cookie, requestId);
                }
                else {
                    var errorResponse = "Exception:||:" + req.status + ":||:" + req.responseText;
                    public.notifySideBarBrowser.PluginWebRequestCompleted(errorResponse, requestUrl, context, cookie, requestId);
                }
            }
        };
        req.send(data);
    }

    function IsWhiteListed(url) {
        var lowered = url.toLowerCase();
        if (lowered.indexOf("http") != 0) {
            return false;
        }

        var lowered = lowered.substr(lowered.indexOf("://") + 3);

        var urlParts = lowered.split("/");

        if(urlParts.length == 1)
            return false;

        return urlParts[0].indexOf("digitalfolio.com") >= 0 && urlParts[1].indexOf("plug_in") == 0;
    }

    this.notifySideBarBrowser = {

        Notify: function (eventName, target) {
            var event = sideBarBrowser.contentDocument.createEvent("Events");
            event.initEvent(eventName, true, false);
            target.dispatchEvent(event);
        },

        BrowserHtmlChanged: function (senderUrl) {
            var context = GetBrowserContext();
            var foliodata = GetFolioDataElement();
            
            if (foliodata) {
                foliodata.setAttribute("currentUrl", context.CurrentUrl);
                foliodata.setAttribute("html", context.BodyHtml);
                foliodata.setAttribute("senderUrl", senderUrl);

                //Application.console.log(context.CurrentUrl + "   " + senderUrl + "   length: " + context.BodyHtml.length);

                this.Notify("BrowserHtmlChanged", foliodata);
            }
        },

        UrlDropped: function (url) {
         //Application.console.log(url);
            var foliodata = GetFolioDataElement();

            if (foliodata) {
                foliodata.setAttribute("droppedUrl", url);

                this.Notify("UrlDropped", foliodata);
            }
        },

        ShowDropZone: function (show) {
            var foliodata = GetFolioDataElement();
            if (foliodata) {
                foliodata.setAttribute("showDropZone", show);
                this.Notify("ShowDropZone", foliodata);
            }
        },

        PluginWebRequestCompleted: function (response, requestUrl, context, cookie, requestId) {
            var data = sideBarBrowser.contentDocument.getElementById(requestId);

            //Application.console.log(requestUrl + "   length: " + response.length);

            data.setAttribute("response", response);
            data.setAttribute("requestUrl", requestUrl);
            data.setAttribute("context", context);
            data.setAttribute("cookie", cookie);
            data.setAttribute("requestId", requestId);

            this.Notify("PluginWebRequestCompleted", data);
        }
    }

    function GetBrowserContext() {
        var mainBrowserDoc = mainWindow.gBrowser.contentDocument;

        return {
            BodyHtml: mainBrowserDoc.body ? mainBrowserDoc.body.parentNode.innerHTML : "",
            CurrentUrl: mainBrowserDoc.body ? mainBrowserDoc.location.href : ""
        };

    }

    function GetFolioDataElement() {       
        if(!sideBarBrowser.contentDocument)
            return;

        folioDataElement = sideBarBrowser.contentDocument.getElementById("DigitalFolioData");

        return folioDataElement;
    }
   
}).apply(DigitalFolio);

window.addEventListener("load", function () {
    DigitalFolio.init();   
}, false);
//window.addEventListener("unload", shutdown, false);












